
#property indicator_chart_window

   
//-------------------------------------------------------------------
   string timeframe = "W1";
   int period = 14;
   extern int x_adjust = 0;
   extern int y_adjust = 0;
   
   extern bool Email = true;
   extern bool Sound = true;

   int Sunday_Breakout = 0; // check if Sunday Breakout Values have been calculated

//-------------------------------------------------------------------
int init()
  {

   return(0);
  }
//-------------------------------------------------------------------
int start()
  {
   int tf=0;
   if (timeframe=="M1")tf=1;
   if (timeframe=="M5")tf=5;
   if (timeframe=="M15")tf=15;
   if (timeframe=="M30")tf=30;
   if (timeframe=="H1")tf=60;
   if (timeframe=="H4")tf=240;
   if (timeframe=="D1")tf=1440;
   if (timeframe=="W1")tf=10080;
   if (timeframe=="MN1" || timeframe=="MN")tf=43200;

   double curr_high = iHigh(Symbol(),tf,0);
   double curr_low = iLow(Symbol(),tf,0);
   double curr_range = (curr_high - curr_low)* MathPow(10,Digits);
   double prev_high = iHigh(Symbol(),tf,1);
   double prev_low = iLow(Symbol(),tf,1);
   double prev_range = (prev_high - prev_low) * MathPow(10,Digits);
   double ATR = (iATR(Symbol(),tf,period,0))* MathPow(10,Digits);

   label ("rnge",x_adjust+5,y_adjust+65);
   ObjectSetText("rnge",timeframe+" RANGE",14,"Comic Sans MS",DimGray);
   label ("c_r",x_adjust+5,y_adjust+45);
   ObjectSetText("c_r","Current "+DoubleToStr(curr_range,0),12,"Comic Sans MS",Gold);
   label ("p_r",x_adjust+5,y_adjust+25);
   ObjectSetText("p_r","Previous "+DoubleToStr(prev_range,0),12,"Comic Sans MS",Gray);
   label ("atr",x_adjust+5,y_adjust+5);
   ObjectSetText("atr","ATR("+period+") "+DoubleToStr(ATR,0),12,"Comic Sans MS",Green);
   
   // check if Sunday Breakout Values have been calculated
   if (Sunday_Breakout == 0)
      // check if it's Monday
      if ( DayOfWeek() == 1)
         // check if it passed GMT 00:00:00
         if ( !StringFind( TimeToStr ( iTime("GBPUSD",PERIOD_H4,0), TIME_SECONDS), "00:00:00", 0) == -1 )
         {
            double CandleHigh, CandleLow, OSP_Buy, OSP_Buy_SL, OSP_Buy_TP;
            double OSP_Sell, OSP_Sell_SL, OSP_Sell_TP, Stop_Loss, Target_Profit, RR;
            double OSP_Buy_When_to_BE, OSP_Sell_When_to_BE;

            CandleHigh           = iHigh("GBPUSD",PERIOD_H4,1);
            CandleLow            = iLow("GBPUSD",PERIOD_H4,1);

            OSP_Buy              = CandleHigh + (10.0 * Point);         //Buy at 10 pips above Candle High
            OSP_Buy_SL           = CandleLow;                           //Stop Price is Candle Low
            OSP_Buy_TP           = OSP_Buy + ((ATR/2.0) * Point);       //Target Profit is half the ATR

            OSP_Sell             = CandleLow - (10.0 * Point);          //Sell at 10 pips below Candle Low
            OSP_Sell_SL          = CandleHigh;                          //Stop Price is Candle High
            OSP_Sell_TP          = OSP_Sell - ((ATR/2.0) * Point);      //Target Profit is half the ATR
            
            Stop_Loss            = (OSP_Buy - OSP_Buy_SL) / Point;
            Target_Profit        = ATR / 2.0;
            RR                   = Target_Profit / Stop_Loss;
            
            // Set SL to break even once your profit has reached 2x your stoploss.
            OSP_Buy_When_to_BE   = OSP_Buy + 2 * (Stop_Loss * Point);
            OSP_Sell_When_to_BE  = OSP_Sell - 2 * (Stop_Loss * Point);


            string str_CandleHigh    = "Candle High: " + DoubleToStr(CandleHigh,4);
            string str_CandleLow     = "Candle Low: " + DoubleToStr(CandleLow,4);
            string str_ATR           = "ATR: " + DoubleToStr(ATR,0);
            string str_OSP_Buy       = "OSP Buy: " + DoubleToStr(OSP_Buy,4);
            string str_OSP_Buy_SL    = "OSP Buy SL: " + DoubleToStr(OSP_Buy_SL,4);
            string str_OSP_Buy_TP    = "OSP Buy TP: " + DoubleToStr(OSP_Buy_TP,4);
            string str_OSP_Sell      = "OSP Sell: " + DoubleToStr(OSP_Sell,4);
            string str_OSP_Sell_SL   = "OSP Sell SL: " + DoubleToStr(OSP_Sell_SL,4);
            string str_OSP_Sell_TP   = "OSP Sell TP: " + DoubleToStr(OSP_Sell_TP,4);
            string str_Stop_Loss     = "Stop Loss (pips): " + DoubleToStr(Stop_Loss,0);
            string str_Target_Profit = "Target Profit (pips): " + DoubleToStr(Target_Profit,0);
            string str_RR            = "Reward to Risk: " + DoubleToStr(RR,1);
            string str_OSP_Buy_SL_BE = "Set OSP Buy SL to BE when: " + DoubleToStr(OSP_Buy_When_to_BE,4);
            string str_OSP_Sell_SL_BE= "Set OSP Sell SL to BE when: " + DoubleToStr(OSP_Sell_When_to_BE,4);

            string email_body =  str_CandleHigh + "\n" +
                                 str_CandleLow + "\n" +
                                 str_ATR + "\n\n" +
                                 
                                 str_OSP_Buy + "\n" +
                                 str_OSP_Buy_SL + "\n" +
                                 str_OSP_Buy_TP + "\n\n" +
                                 
                                 str_OSP_Sell + "\n" +
                                 str_OSP_Sell_SL + "\n" +
                                 str_OSP_Sell_TP + "\n\n" +
                                 
                                 str_Stop_Loss + "\n" +
                                 str_Target_Profit + "\n" +
                                 str_RR + "\n\n" +
                                 
                                 str_OSP_Buy_SL_BE + "\n" +
                                 str_OSP_Sell_SL_BE;
                                 
            // send out email notification if user wants it
            if (Email) SendMail ("phil838's Sunday Breakout on GBP/USD", email_body);    
            Comment("");    // to display it on screen - find that too much to be on screen; lines to be on screen instead

            // Drawing OSP Buy on the screen
            Draw_HLine ("OSP_Buy", str_OSP_Buy, OSP_Buy, Aqua);
            Draw_HLine ("OSP_Buy_SL", str_OSP_Buy_SL, OSP_Buy_SL, Aqua);
            Draw_HLine ("OSP_Buy_TP", str_OSP_Buy_TP, OSP_Buy_TP, Aqua);
            Draw_HLine ("OSP_Buy_Breakeven_point", str_OSP_Buy_SL_BE, OSP_Buy_When_to_BE, Aqua);
            
            // Drawing OSP Sell on the screen
            Draw_HLine ("OSP_Sell", str_OSP_Sell, OSP_Sell, Red);
            Draw_HLine ("OSP_Sell_SL", str_OSP_Sell_SL, OSP_Sell_SL, Red);
            Draw_HLine ("OSP_Sell_TP", str_OSP_Sell_TP, OSP_Sell_TP, Red);
            Draw_HLine ("OSP_Sell_Breakeven_point", str_OSP_Sell_SL_BE, OSP_Sell_When_to_BE, Red);

            Sunday_Breakout = 1;
         }  
         
   else

      // when the Ask price reaches 2x the stop loss, alert the user
      if (Ask == OSP_Buy_When_to_BE)
      {
         if (Sound) Alert("Ask Price has reached twice the stop loss for your OSP Buy Entry! Move your stop loss to Breakeven");
         if (Email) SendMail("phil838's Sunday Breakout on GBP/USD", "Ask Price has reached twice the stop loss for your OSP Buy Entry! Move your stop loss to Breakeven");
      }
      
      // when the Bid price reaches 2x the stop loss, alert the user      
      if (Bid == OSP_Sell_When_to_BE)
      {
         if (Sound) Alert("Bid Price has reached twice the stop loss for your OSP Sell Entry! Move your stop loss to Breakeven");
         if (Email) SendMail("phil838's Sunday Breakout on GBP/USD", "Bid Price has reached twice the stop loss for your OSP Sell Entry! Move your stop loss to Breakeven");
      }

   return(0);
  }
//-------------------------------------------------------------------

int deinit()
  {
   ObjectDelete("rnge");
   ObjectDelete("c_r");
   ObjectDelete("p_r");
   ObjectDelete("atr");
   
   return(0);
  }
//-------------------------------------------------------------------



void label(string name,int X,int Y,int corner=3)
   {
    ObjectCreate(name,OBJ_LABEL,0,0,0);
    ObjectSet(name,OBJPROP_CORNER,corner);
    ObjectSet(name,OBJPROP_XDISTANCE,X);
    ObjectSet(name,OBJPROP_YDISTANCE,Y);
   }
   
   

// Draw Horizontal line
void Draw_HLine (string LineName, string LineLabel, double LineValue, int LineColor)
{
   ObjectCreate(LineName, OBJ_HLINE, 0, Time[0], LineValue);
   ObjectSetText(LineName, LineLabel, 8, "Arial", EMPTY);
   ObjectSet(LineName, OBJPROP_WIDTH,1);
   ObjectSet(LineName, OBJPROP_COLOR, LineColor);    
}